class UsersController < ApplicationController

  before_action :authenticate_user!, only: :me
  before_action :check_current_user_page, only: :show
  before_action :set_user, only: :show

  def show
    @objects = learning_object_repository.all_from_offset_to_limit 0, 10
    @new_collection = Collection.new

    @groups = [
        CollectionsGroup.new(title: 'Coleções Automáticas',
                             collections: [
                                 @new_collection
                             ]),
        CollectionsGroup.new(title: 'Coleções adicionadas',
                             collections: [
                                 @new_collection
                             ])
    ]
  end

  def me
    @objects = learning_object_repository.all_from_offset_to_limit 0, 10
    @new_collection = Collection.new
    @new_collection.name = 'Favoritos'

    @groups = [
        CollectionsGroup.new(title: 'Coleções Automáticas',
                             collections: [
                                 @new_collection
                             ]),
        CollectionsGroup.new(title: 'Coleções adicionadas',
                             collections: [
                                 @new_collection
                             ])
    ]
  end


  private

  def set_user
    @user = user_repository.find params[:id]
  end

  def check_current_user_page
    if user_signed_in?
      if current_user.id == params[:id]
        redirect_to action: :me
      end
    end
  end

end
