module OrientDb
  class SubjectRepository < Base
    include OrientDb::Methods::EdgeMethods
    include RepositoriesProxy

    def find_by_name(name)
      result = select_by_property(odb_class, "name", name)
      build_object(result.first)
    end

    def destroy(id)
      connection.command "DELETE VERTEX Subject where @rid = '#{id}'"
    end

    def update(id, operation, atributte, new_value)
      puts "update #{id} #{operation} #{atributte} = #{new_value}"
      connection.command "update #{id} #{operation} #{atributte} = #{new_value}"
    end

    def get_learning_objects(subject)
      result = get_edges_end("IsAbout", "in", subject.id)
      learning_object_repository.build_objects(result)
    end

    def get_highlights(subject)
      result = connection.query "SELECT expand(highlights) FROM #{subject.id}"
      learning_object_repository.build_objects(result)
    end

    def build_hash(object)
      hash = super(object)
      hash.delete("learning_objects")
      hash
    end

    def build_object(args={})
      subject = nil
      unless args.nil?
        subject = Subject.new(:id => args["@rid"])
        args.each do |var, val|
          var_name = "@"+var
          if subject.respond_to?(var) && var != 'highlights'
            subject.instance_variable_set(var_name, val)
          end
        end
      end
      subject
    end

    private

    def odb_class
      "Subject"
    end

  end
end
