module OrientDb
  module Methods
    module EdgeMethods

      def create_edges_from_array(edge_class, id, array, unique=false)
        edges = []
        array.each do |o|
          unless unique && edge_exists?(edge_class, id, o.id)
            edges << create_edge(edge_class, id, o.id)
          end
        end
        edges
      end

      ##
      # Count the number of edges existent
      def get_in_edges_count(edge_class, id)
        result = connection.query "SELECT in('#{edge_class}').size() AS COUNT FROM #{id}"
        result.first["COUNT"].to_i
      end

      def create_edge(edge_class, from_id, to_id)
        connection.command "CREATE EDGE #{edge_class} FROM #{from_id} TO #{to_id}"
      end

      def get_edges_end(edge_class, type, vertex_id)
        connection.query sprintf("SELECT expand(%s('%s')) FROM %s", type, edge_class, vertex_id)
      end

      def edge_exists?(edge_class, from_id, to_id)
        edge = connection.query sprintf("SELECT outE('%s') FROM %s WHERE out('%s') CONTAINS %s", edge_class, from_id, edge_class, to_id)
        !edge.empty?
      end

    end
  end
end
