module OrientDb

  ##
  # This class represents an orient db migration
  #
  # The purpose of this class is to be an abstract class,
  # and extendend by concrete migrations
  class Migration

    def initialize(client)
      @client = client
    end

    protected

    ##
    # Create a orient db class in graph schema
    #
    # If +klass+ exists in current schema, nothing happens.
    #
    # A block can be passed with the created +klass+ object
    def create_class(klass)
      unless @client.class_exists? klass
        @client.create_class(klass) do |c|
          if block_given?
            yield c
          end
        end
      end
    end
  end
end