module Thumbnail
  module Formats

    def file_format file
      unless file.nil?
        file_format = File.extname(file)
      else
        file_format = ""
      end
      file_format
    end

    def accepted_video_formats
      lower = [".mp4", ".wmv", ".3gp", ".asf", ".avi", ".flv", ".mov", ".mpg", ".mpeg", ".rmvb", ".vob", ".webm"]
      upper = [".MP4", ".WMV", ".3GP", ".ASF", ".AVI", ".FLV", ".MOV", ".MPG", ".MPEG", ".RMVB", ".VOB", ".WEBM"]
      return lower + upper
    end

    def accepted_image_formats
      lower = [".jpg", ".jpeg", ".gif", ".png", ".bmp", ".tif"]
      upper = [".JPG", ".JPEG", ".GIF", ".PNG", ".BMP", ".TIF"]
      return lower + upper
    end

    def accepted_other_formats
      lower = [".pdf", ".pps"]
      upper = [".PDF", ".PPS"]
      return lower + upper
    end

    def accepted_formats
      return accepted_video_formats + accepted_image_formats + accepted_other_formats
    end

  end
end
